/*
  * Copyright (C) 1997 Anti Sullin <anti.sullin@artecdesign.ee>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <version.h>

// 200M
#define AT91C_PLLA_VALUE 		0x203ABF04

// 190M
//#define AT91C_PLLA_VALUE 		0x2038BF04

// 150M
//#define AT91C_PLLA_VALUE 		0x202DBF04

 .globl lowlevel_init
lowlevel_init:
// ================================= INITIALIZE SMC =====================================

  // CS0 FLASH: 0 setup, 8 clks pulse time, 8 clks total time (no hold time)

	ldr r1, =0xffffec00
	ldr r2, =0x00000000
	str r2, [r1]
	//AT91C_BASE_SYS->SMC_SETUP0 = ...;

	ldr r1, =0xffffec04
	ldr	r2, =0x0A0A0A0A
	str r2, [r1]
	//AT91C_BASE_SYS->SMC_PULSE0 = ...;

	ldr r1, =0xffffec08
	ldr	r2, =0x0A0A0A0A
	str r2, [r1]
	//AT91C_BASE_SYS->SMC_CYCLE0 = ...;

	ldr r1, =0xffffec0c
	ldr	r2, =0x00001100
	str r2, [r1]
  //AT91C_BASE_SYS->SMC_CTRL0 = ...;


  // CS2 EXT UART: 0 setup, 8 clks pulse time, 8 clks total time (no hold time)

	ldr r1, =0xffffec20
	ldr	r2, =0x01020102
	str r2, [r1]
  //AT91C_BASE_SYS->SMC_SETUP2 = 0x01020102;

	ldr r1, =0xffffec24
	ldr	r2, =0x0A080A08
	str r2, [r1]
  //AT91C_BASE_SYS->SMC_PULSE2 = 0x0A080A08;

	ldr r1, =0xffffec28
	ldr	r2, =0x00150015
	str r2, [r1]
  //AT91C_BASE_SYS->SMC_CYCLE2 = 0x00150015;

	ldr r1, =0xffffec2c
	ldr	r2, =0x00000100
	str r2, [r1]
  //AT91C_BASE_SYS->SMC_CTRL2 = 0x00000100;


// ================================= INITIALIZE MAIN OSC =====================================

	ldr r1, =0xfffffc20
	ldr	r2, =0x0000FF01
	str r2, [r1]
	/* - Start main oscillator */
	//pSys->PMC_MOR = MOSC_STARTUP_TIME | MOSC_ENABLE;


	/* Wait until the main oscillator is ready*/
	//while (!(*AT91C_PMC_SR & AT91C_PMC_MOSCRDY));
	ldr r1, =0xfffffc68
main_osc_startup_loop:
	ldr r2, [r1]
	ands r2, r2, #0x00000001
	beq main_osc_startup_loop



	/* - Switch Master Clock from SLCLK to MCLK/2
 	 *  Needed because we cannot switch to PLL clock and /2 divider at once,
 	 *  the divider must be set earlier. So, better switch to a faster clock here. */
	ldr r3, =0xfffffc30
	ldr	r4, =0x00000101
	str r4, [r3]

	//while (!(*AT91C_PMC_SR & AT91C_PMC_MCKRDY));
mckrdy1_loop:
	ldr r2, [r1]
	ands r2, r2, #0x00000008
	beq mckrdy1_loop

// ================================= INITIALIZE CLOCKS =====================================

	ldr r1, =0xfffffc64
	ldr	r2, =0xFFFFFFFF
	str r2, [r1]
	//pPmc->PMC_IDR = 0xFFFFFFFF;

  /* Enable clocks for SYS(SMC) and PIOC */
	ldr r1, =0xFFFFFC10
	mov	r2, #2
	str r2, [r1]
  //*AT91C_PMC_PCER = 1 << AT91C_ID_SYS;

	ldr r1, =0xFFFFFC10
	mov	r2, #16
	str r2, [r1]
  //*AT91C_PMC_PCER = 1 << AT91C_ID_PIOC;


// ================================= INITIALIZE PLL =====================================

	ldr r1, =0xfffffc28
	ldr	r2, =AT91C_PLLA_VALUE
	str r2, [r1]
	/* - Setup the PLL A */
	//pSys->PMC_PLLAR = AT91C_PLLA_VALUE;

	//while (!(*AT91C_PMC_SR & AT91C_PMC_LOCKA));
	ldr r1, =0xfffffc68
pll_lock_loop:
	ldr r2, [r1]
	ands r2, r2, #0x00000002
	beq pll_lock_loop

	/* - Switch Master Clock from MCLK/2 to PLLA/2 */
	//pPmc->PMC_MCKR = AT91C_PMC_CSS_PLLA_CLK | AT91C_PMC_PRES_CLK_2 | AT91C_PMC_MDIV_2; // PCK = 2 * MCK
	//pPmc->PMC_MCKR = AT91C_PMC_CSS_PLLA_CLK | AT91C_PMC_PRES_CLK | AT91C_PMC_MDIV_2; // PCK = MCK = 48 Mhz
	ldr r3, =0xfffffc30
	ldr	r4, =0x00000102
	//ldr	r4, =0x00000202
	str r4, [r3]

	//while (!(*AT91C_PMC_SR & AT91C_PMC_MCKRDY));
mckrdy_loop:
	ldr r2, [r1]
	ands r2, r2, #0x00000008
	beq mckrdy_loop

// ================================ INITIALIZE SDRAMC ===================================

	adr	r0, lowlevel_init 		/* load pointer to this function to r0 */
	and r0, r0, #0xF0000000
	cmp     r0, #0x20000000     /* don't init sdram if we're running already in sdram */
	beq     sdram_init_end



	ldr r1, =0xFFFFEE30
	mov	r2, #0x00000002
	str r2, [r1]
	//MATRIX_EBI_CSA	= 0x00000002;		// Configure CS1 as SDRAM, others as static

	ldr r1, =0xffffea08
	//ldr	r2, =0x852272DA // 64M
	ldr	r2, =0x852272D9 // 32M
	//ldr	r2, =0x852272D5 // 16M

	str r2, [r1]

//	delay ~20000 clock cycles * 2 instructions per cycle = at least 200us
	mov r2,#0x5000
wait_loop1:
	subs r2, r2, #1
	bne wait_loop1
	//for (i =0; i<x; i++);

	ldr r1, =0xFFFFEA00
	mov	r2, #0x00000001
	str r2, [r1]
	//psdrc->SDRAMC_MR	= 0x00000001;		// MODE 1 = NOP


	mov r3, #0x20000000
	mov r4, #0
	str r4, [r3]
	//*AT91C_SDRAM	= 0x00000000;			// Perform NOP

	mov	r2, #0x00000002
	str r2, [r1]
	//psdrc->SDRAMC_MR	= 0x00000002;		// Set PRCHG AL

	str r4, [r3]
	//*AT91C_SDRAM	= 0x00000000;			// Perform PRCHG

//	delay ~20000 clock cycles * 2 instructions per cycle = at least 200us
	mov r2,#0x5000
wait_loop2:
	subs r2, r2, #1
	bne wait_loop2
	//for (i =0; i< x; i++);

	mov	r2, #0x00000004
	str r2, [r1]
	//psdrc->SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;		// Set mode= all banks precharge

	str r4, [r3]
	str r4, [r3]
	str r4, [r3]
	str r4, [r3]
	str r4, [r3]
	str r4, [r3]
	str r4, [r3]
	str r4, [r3]
	//*AT91C_SDRAM	= 0x00000000;	// Perform 8 CBR cycles

	mov r2, #0x00000003
	str r2, [r1]
	//psdrc->SDRAMC_MR	= AT91C_SDRAMC_MODE_LMR_CMD;		// Set LMR operation
	ldr r4, =0xcafedede
	str r4, [r3, #20]
	//*(AT91C_SDRAM + 20)	= 0xcafedede;		// Perform LMR burst=1, lat=2



//	ldr	r2, =((AT91C_MASTER_CLOCK * 781)/100000000)
//	ldr	r2, =781
	ldr	r2, =595
	str r2, [r1, #0x04]
	//psdrc->SDRAMC_TR	= (AT91C_MASTER_CLOCK * 7.81)/1000000;				// Set Refresh Timer 390 for 25MHz (TR= 15.6 * F )
																// (F : system clock freq. MHz

	mov	r2, #0x00000000
	str r2, [r1]
	//psdrc->SDRAMC_MR	= AT91C_SDRAMC_MODE_NORMAL_CMD;		// Set Normal mode
	mov r4, #0x0
	str r4, [r3]
	//*AT91C_SDRAM	= 0x00000000;	// Perform Normal mode

sdram_init_end:

// =========================== COPY BOOTSPLASH IMAGE TO SRAM ============================


#ifdef COPY_BOOTSPLASH_TO_SRAM
	ldr	r0, =BOOTSPLASH_ADDR		/* src pointer  */
	ldr	r1, =0x300000				/* destination pointer */
	ldr	r2, =BOOTSPLASH_END_ADDR	/* src end */

bootsplash_loop:
	ldmia	r0!, {r3-r10}		/* copy from source address [r0]    */
	stmia	r1!, {r3-r10}		/* copy to   target address [r1]    */
	cmp	r0, r2			/* until source end addreee [r2]    */
	ble	bootsplash_loop
#endif

// =========================== ENABLE SDRAM POWER-SAVING ============================

	// Self-refresh automatically with 64-clock delay
	ldr r1, =0xffffea10
	ldr	r2, =0x00001001
	str r2, [r1]

	/* return */
	mov	pc, lr
