

#include <config.h>
#include <common.h>
#include <version.h>
#include <stdarg.h>
#include <linux/types.h>
#include <devices.h>

#include <asm/arch/hardware.h>

#include <asm/arch/pio.h>

#include <beep.h>
#include <command.h>

#ifdef CONFIG_AT91_BEEPER

#define BEEPFREQ 1000
#define BEEPFREQ_CMD 500
#define CLKFREQ (100000000/128)
#define DIV_CMD (CLKFREQ / BEEPFREQ_CMD)
#define DIV (CLKFREQ / BEEPFREQ)
#define CMD_BEEP_LEN 1000000
#define ERROR_BEEP_LEN 500000
#define OK_BEEP_LEN 50000

#define tc_writel(reg,value) ((AT91C_BASE_TC1->TC_##reg)=(value))

void beeper_init(void) {

	AT91C_BASE_PMC->PMC_PCER = 1 << AT91C_ID_PIOC;
	AT91C_BASE_PMC->PMC_PCER = 1 << AT91C_ID_TC1;	/* enable clock */

	AT91F_PIO_CfgPeriph(AT91C_BASE_PIOC, 0 , AT91C_PIO_PC21);

	//turn on amp
	AT91F_PIO_CfgOutput(AT91C_BASE_PIOC, AT91C_PIO_PC20);
	AT91F_PIO_ClearOutput(AT91C_BASE_PIOC, AT91C_PIO_PC20);
}

void beep(int type){

	tc_writel(IDR, 0xFF); // disable all int's
	tc_writel(CCR, AT91C_TC_CLKEN); // enable clk
	tc_writel(CCR, AT91C_TC_SWTRG); // trigger clk start
	tc_writel(CMR, AT91C_TC_CLKS_TIMER_DIV4_CLOCK |
		AT91C_TC_WAVE | AT91C_TC_WAVESEL_UP_AUTO |
		AT91C_TC_ACPA_CLEAR | AT91C_TC_ACPC_SET | AT91C_TC_ASWTRG_CLEAR);

	if (type==BEEP_CMD) {
		tc_writel(RA, DIV_CMD>>1); // pulse width 50%
		tc_writel(RC, DIV_CMD); // frequency == timer length
		udelay(CMD_BEEP_LEN);
	}
	else {
		tc_writel(RA, DIV>>1); // pulse width 50%
		tc_writel(RC, DIV); // frequency == timer length
		//sleep
		if (type==BEEP_ERROR)
			udelay(ERROR_BEEP_LEN);
		else
			udelay(OK_BEEP_LEN);
	}


	tc_writel(CCR, AT91C_TC_CLKDIS); // disable clk
	tc_writel(CCR, AT91C_TC_SWTRG); // trigger output to go to inactive


}

int do_beep (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	beep(BEEP_CMD);
	return 0;
}


U_BOOT_CMD(beep, 1, 1, do_beep,
	   "beep - signal ready condition\n",
	   "");


#else
void beeper_init(void) {}
void beep(int type){}
#endif
